#include <string.h>
#include <signal.h>

#include <iostream>
#include <iomanip>

#include "Process.h"

//----------------------------------------------------------------------------
Process *Process::m_this = NULL;

//----------------------------------------------------------------------------
Process::Process()
{
    m_this = this;
    initSignalHandler();
}

//----------------------------------------------------------------------------
Process::~Process()
{
}


//----------------------------------------------------------------------------
void Process::initSignalHandler()
{
    struct sigaction sa;
    memset(&sa, 0, sizeof(sa));
    sa.sa_handler = signalHandler;
    sigaction(SIGTERM, &sa, NULL);
    sigaction(SIGINT,  &sa, NULL);
}

//----------------------------------------------------------------------------
void Process::signalHandler(int sig)
{
    switch (sig)
    {
      case SIGINT:
      case SIGTERM:
        m_this->onTerm();
        break;

      default:
        std::cerr << "Signal " << sig << " not handled." << std::endl;
    }
}
